"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var expand_environment_variables_exports = {};
__export(expand_environment_variables_exports, {
  expandEnvironmentVariables: () => expandEnvironmentVariables
});
module.exports = __toCommonJS(expand_environment_variables_exports);
var import_assert = require("@code-like-a-carpenter/assert");
function expandEnvironmentVariables() {
  const tableNames = process.env.FOUNDATION_TABLE_NAMES;
  if (tableNames) {
    const tables = JSON.parse(tableNames);
    for (const [key, value] of Object.entries(tables)) {
      (0, import_assert.assert)(
        typeof value === "string",
        "FOUNDATION_TABLE_NAMES should only contain string values"
      );
      process.env[key] = value;
    }
  }
  const envVars = process.env.FOUNDATION_ENVIRONMENT_VARIABLES;
  if (envVars) {
    const env = JSON.parse(envVars);
    for (const [key, value] of Object.entries(env)) {
      (0, import_assert.assert)(
        typeof value === "string",
        "FOUNDATION_ENVIRONMENT_VARIABLES should only contain string values"
      );
      process.env[key] = value;
    }
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  expandEnvironmentVariables
});
