"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var handlers_exports = {};
__export(handlers_exports, {
  makeSqsHandler: () => makeSqsHandler
});
module.exports = __toCommonJS(handlers_exports);
var import_assert = require("@code-like-a-carpenter/assert");
var import_lambda_handlers = require("@code-like-a-carpenter/lambda-handlers");
var import_retry = require("./retry");
var import_unmarshall_record = require("./unmarshall-record");
function makeSqsHandler(cb) {
  return (0, import_lambda_handlers.handleSQSEvent)(async (record, context) => {
    const eventBridgeRecord = JSON.parse(record.body);
    (0, import_assert.assert)(
      "detail" in eventBridgeRecord,
      'EventBridge record is missing "detail" field'
    );
    (0, import_assert.assert)(
      "dynamodb" in eventBridgeRecord.detail,
      'EventBridge record is missing "detail.dynamodb" field'
    );
    const ddbRecord = eventBridgeRecord.detail;
    const unmarshalledRecord = (0, import_unmarshall_record.unmarshallRecord)(ddbRecord);
    return await (0, import_retry.retry)(() => cb(unmarshalledRecord, context.context));
  });
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  makeSqsHandler
});
