"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var make_multi_reducer_exports = {};
__export(make_multi_reducer_exports, {
  MultiReducer: () => MultiReducer,
  makeMultiReducer: () => makeMultiReducer
});
module.exports = __toCommonJS(make_multi_reducer_exports);
var import_assert = require("@code-like-a-carpenter/assert");
var import_handlers = require("../common/handlers");
function makeMultiReducer(constructor, sdk) {
  const reducer = new constructor(sdk);
  return (0, import_handlers.makeSqsHandler)(async (record) => {
    await reducer.reduce(record);
  });
}
class MultiReducer {
  sdk;
  constructor(sdk) {
    this.sdk = sdk;
  }
  async reduce(unmarshalledRecord) {
    const { createTargetModel, updateTargetModel, unmarshallSourceModel } = this.sdk;
    (0, import_assert.assert)(
      unmarshalledRecord.dynamodb?.NewImage,
      "NewImage missing from DynamoDB Stream Event. This should never happen."
    );
    const source = unmarshallSourceModel(unmarshalledRecord.dynamodb?.NewImage);
    const previous = unmarshalledRecord.dynamodb?.OldImage && unmarshallSourceModel(unmarshalledRecord.dynamodb.OldImage);
    const sources = await this.loadSources(source, previous);
    const target = await this.loadTargets(source, previous);
    const models = await this.createOrUpdate(source, sources, target, previous);
    const modelsToCreate = models.filter(
      (model) => !("version" in model)
    );
    const modelsToUpdate = models.filter(
      (model) => "version" in model
    );
    await Promise.all([
      Promise.all(modelsToCreate.map((model) => createTargetModel(model))),
      Promise.all(modelsToUpdate.map((model) => updateTargetModel(model)))
    ]);
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  MultiReducer,
  makeMultiReducer
});
