"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var make_reactor_exports = {};
__export(make_reactor_exports, {
  Reactor: () => Reactor,
  makeReactor: () => makeReactor
});
module.exports = __toCommonJS(make_reactor_exports);
var import_assert = require("@code-like-a-carpenter/assert");
var import_handlers = require("../common/handlers");
function makeReactor(constructor, sdk) {
  const reactor = new constructor(sdk);
  return (0, import_handlers.makeSqsHandler)(async (record) => {
    await reactor.react(record);
  });
}
class Reactor {
  sdk;
  constructor(sdk) {
    this.sdk = sdk;
  }
  react(unmarshalledRecord) {
    const { unmarshallSourceModel } = this.sdk;
    (0, import_assert.assert)(
      unmarshalledRecord.dynamodb?.NewImage,
      "NewImage missing from DynamoDB Stream Event. This should never happen."
    );
    const source = unmarshallSourceModel(unmarshalledRecord.dynamodb?.NewImage);
    const previous = unmarshalledRecord.dynamodb?.OldImage && unmarshallSourceModel(unmarshalledRecord.dynamodb.OldImage);
    return this.handle(source, previous);
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Reactor,
  makeReactor
});
