"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var make_table_dispatcher_exports = {};
__export(make_table_dispatcher_exports, {
  makeDynamoDBStreamDispatcher: () => makeDynamoDBStreamDispatcher
});
module.exports = __toCommonJS(make_table_dispatcher_exports);
var import_client_eventbridge = require("@aws-sdk/client-eventbridge");
var import_lambda_handlers = require("@code-like-a-carpenter/lambda-handlers");
async function handleRecord({ eventBridge, tableName }, record) {
  const modelName = record.dynamodb?.NewImage?._et.S;
  const entry = {
    Detail: JSON.stringify(record),
    DetailType: record.eventName,
    Resources: record.eventSourceARN ? [record.eventSourceARN.split("/stream")[0]] : [],
    Source: [tableName, modelName].join("."),
    Time: record.dynamodb?.ApproximateCreationDateTime ? new Date(record.dynamodb.ApproximateCreationDateTime) : void 0
  };
  await eventBridge.send(
    new import_client_eventbridge.PutEventsCommand({
      Entries: [entry]
    })
  );
}
function makeDynamoDBStreamDispatcher(dependencies) {
  return (0, import_lambda_handlers.handleDynamoDBStreamEvent)(
    async (record) => await handleRecord(dependencies, record)
  );
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  makeDynamoDBStreamDispatcher
});
