import { BaseDataLibraryError } from "./base-error";
class AlreadyExistsError extends BaseDataLibraryError {
  primaryKey;
  typeName;
  /** constructor */
  constructor(typename, primaryKey) {
    super(
      `${typename} with specified primaryKey already exists. Please switch to update${typename} instead of create${typename}.`,
      { telemetry: { primaryKey, typename } }
    );
    this.primaryKey = primaryKey;
    this.typeName = typename;
  }
}
export {
  AlreadyExistsError
};
