import { BaseDataLibraryError } from "./base-error";
class OptimisticLockingError extends BaseDataLibraryError {
  primaryKey;
  typeName;
  /** constructor */
  constructor(typename, primaryKey) {
    super(
      `${typename} with specified primaryKey is out of date. Please refresh and try again.`,
      { telemetry: { primaryKey, typename } }
    );
    this.primaryKey = primaryKey;
    this.typeName = typename;
  }
}
export {
  OptimisticLockingError
};
