import { assert } from "@code-like-a-carpenter/assert";
import { handleSQSEvent } from "@code-like-a-carpenter/lambda-handlers";
import { retry } from "./retry";
import { unmarshallRecord } from "./unmarshall-record";
function makeSqsHandler(cb) {
  return handleSQSEvent(async (record, context) => {
    const eventBridgeRecord = JSON.parse(record.body);
    assert(
      "detail" in eventBridgeRecord,
      'EventBridge record is missing "detail" field'
    );
    assert(
      "dynamodb" in eventBridgeRecord.detail,
      'EventBridge record is missing "detail.dynamodb" field'
    );
    const ddbRecord = eventBridgeRecord.detail;
    const unmarshalledRecord = unmarshallRecord(ddbRecord);
    return await retry(() => cb(unmarshalledRecord, context.context));
  });
}
export {
  makeSqsHandler
};
