import type { NativeAttributeValue } from '@aws-sdk/util-dynamodb/dist-types/models';
import type { DynamoDBRecord, StreamRecord } from 'aws-lambda';
type UnmarshalledStreamRecord = Omit<StreamRecord, 'NewImage' | 'OldImage'> & {
    NewImage?: Record<string, NativeAttributeValue> | undefined;
    OldImage?: Record<string, NativeAttributeValue> | undefined;
};
export type UnmarshalledDynamoDBRecord = Omit<DynamoDBRecord, 'dynamodb'> & {
    dynamodb: UnmarshalledStreamRecord;
};
/** Unmarshalls a DynamoDB record so it can be used like something reasonable */
export declare function unmarshallRecord(ddbRecord: DynamoDBRecord): UnmarshalledDynamoDBRecord;
export {};
//# sourceMappingURL=unmarshall-record.d.ts.map